"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.filterDuplicateDescriptor = void 0;
/**
 * Remove duplicated descriptor
 * For example, A1 equals to A2
 * [A1, B, A2]
 * => filter
 * [A1, B]
 */
exports.filterDuplicateDescriptor = function (descriptors) {
    var newDescriptorList = [];
    descriptors.forEach(function (descriptor) {
        var existsDescriptor = newDescriptorList.some(function (existDescriptor) {
            return existDescriptor.equals(descriptor);
        });
        if (!existsDescriptor) {
            newDescriptorList.push(descriptor);
        }
    });
    return newDescriptorList;
};
//# sourceMappingURL=DescriptorUtil.js.map