// LICENSE : MIT
"use strict";
import { TextlintFilterRuleDescriptor } from "./TextlintFilterRuleDescriptor";
import { TextlintFilterRuleDescriptors } from "./TextlintFilterRuleDescriptors";
import { TextlintRuleDescriptors } from "./TextlintRuleDescriptors";
import { TextlintLintableRuleDescriptor } from "./TextlintLintableRuleDescriptor";
import { TextlintPluginDescriptors } from "./TextlintPluginDescriptors";
import { TextlintPluginDescriptor } from "./TextlintPluginDescriptor";
import { hasFixer } from "./rule-creator-helper";
import { TextlintFixableRuleDescriptor } from "./TextlintFixableRuleDescriptor";
export var createTextlintRuleDescriptors = function (rules) {
    var ruleOrFixableRuleDescriptorList = rules.map(function (rule) {
        if (hasFixer(rule.rule)) {
            return new TextlintFixableRuleDescriptor(rule);
        }
        else {
            return new TextlintLintableRuleDescriptor(rule);
        }
    });
    return new TextlintRuleDescriptors(ruleOrFixableRuleDescriptorList);
};
export var createTextlintFilterRuleDescriptors = function (rules) {
    return new TextlintFilterRuleDescriptors(rules.map(function (rule) { return new TextlintFilterRuleDescriptor(rule); }));
};
export var createTextlintPluginDescriptors = function (rules) {
    return new TextlintPluginDescriptors(rules.map(function (rule) { return new TextlintPluginDescriptor(rule); }));
};
//# sourceMappingURL=DescriptorsFactory.js.map