// LICENSE : MIT
"use strict";
import CoreTask from "./textlint-core-task";
var TaskRunner = /** @class */ (function () {
    function TaskRunner() {
    }
    /**
     * Task and return promise
     * @param {TextLintCoreTask} task
     * @returns {Promise}
     */
    TaskRunner.process = function (task) {
        return new Promise(function (resolve, reject) {
            var messages = [];
            task.on(CoreTask.events.message, function (message) {
                messages.push(message);
            });
            task.on(CoreTask.events.error, function (error) {
                reject(error);
            });
            task.on(CoreTask.events.complete, function () {
                task.removeAllListeners();
                resolve(messages);
            });
            task.start();
        });
    };
    return TaskRunner;
}());
export default TaskRunner;
//# sourceMappingURL=task-runner.js.map